Attribute VB_Name = "modDeclare"
Option Explicit
'----------------------------------------------------------'
' Versione     :    1.1                                    '
' Data         :    10/01/2001                             '
' Data ver 1.0 :    08/01/2001                             '
' Diff. da 1.0 :    1.1 - Eliminato bug di visualizzazione '
'                   pulsante anche su form sovrapposte     '
' Autore       :    Sirri Moreno (sirri@morenosoft.com)    '
' Descrizione  :    Questo codice permette di aggiungere   '
'                   un pulsante alla barra del titolo      '
' Migliorie    :    Nella routine CallWndProc, si potrebbe '
'                   sostituire il valore 75 con uno pi    '
'                   appropriato nel caso in cui non tutti  '
'                   i pulsanti della barra del titolo siano'
'                   visibili a causa di un diverso valore  '
'                   della propriet .BorderStyle del form  '
' Limitazioni  :    Nella routine CallWndProc, il messagio '
'                   WM_COMMAND non viene riconosciuto da   '
'                   Windows NT / Windows 2000              '
' Licenza      :    Il suo utilizzo  libero. Nel caso in  '
'                   cui vengano resi pubblici i sorgenti   '
'                   di un programma che utilizza questo    '
'                   codice, si prega di citare l'autore.   '
'----------------------------------------------------------'

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As Rect) As Long
Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook&, ByVal lpfn&, ByVal hmod&, ByVal dwThreadId&) As Long
Public Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook&) As Long

Public Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type CWPSTRUCT
    lParam As Long
    wParam As Long
    Message As Long
    hwnd As Long
End Type

Public Const WM_MOVE = &H3
Public Const WM_SETCURSOR = &H20
Public Const WM_NCPAINT = &H85
Public Const WM_COMMAND = &H111
Public Const WS_EX_TOOLWINDOW = &H80
Public Const SWP_FRAMECHANGED = &H20
Public Const GWL_EXSTYLE = -20
Public Const HWND_TOP = 0
Public Const WH_CALLWNDPROC = 4

'//////////////////////////////////////////////////////
' Per vedere se  gi in esecuzione update.exe
Public oldproc As Long
Public cmdButtonHwnd As Long
Public Const MAX_PATH As Long = 260
Public Const LB_SETTABSTOPS As Long = &H192
Public Declare Function EnumWindows Lib "User32.dll" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function GetWindowText Lib "User32.dll" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetWindowTextLength Lib "User32.dll" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Public Declare Function SendMessage Lib "User32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public UpdateOnEx As Boolean    'Serve per verificare se Spegni Pc  gi in esecuzione

Public Function UpdateEsecuzione(ByVal hwnd As Long, ByVal lParam As Long) As Boolean
    Dim nSize As Long
    Dim sTitle As String
    Dim pos As Integer
    sTitle = Space$(MAX_PATH)
    Call GetWindowText(hwnd, sTitle, MAX_PATH)
    pos = InStr(sTitle, Chr$(0))
    If pos Then
        sTitle = Left$(sTitle, pos - 1)
    Else
        sTitle = ""  'Non aggiunge il carattere di tabulazione, poich  l'ultimo elemento della linea.
    End If
    If InStr(1, sTitle, "SP --> Verifica disponibilit Aggiornamenti") > 0 Then
        UpdateOnEx = True
    End If
    UpdateEsecuzione = True
End Function
'//////////////////////////////////////////////
'Fine Sezione Per vedere Task update.exe

Public Function CallWndProc(ByVal nCode As Long, ByVal wParam As Long, Inf As CWPSTRUCT) As Long
On Error Resume Next

Dim FormRect As Rect
Dim ActiveFormRect As Rect
    
    Select Case Inf.Message
        Case WM_COMMAND
            If Inf.lParam = cmdButtonHwnd Then
                
                Call frmMain.cmdRiduci_Click
            
            End If
        Case WM_NCPAINT Or Inf.Message = WM_MOVE
            
            If Screen.ActiveForm.Name = frmMain.Name Then
                Call GetWindowRect(frmMain.hwnd, FormRect)
                Call SetWindowPos(cmdButtonHwnd, HWND_TOP, FormRect.Right - 55, FormRect.Top + 11, 17, 12, SWP_FRAMECHANGED)
            Else
                Call GetWindowRect(frmMain.hwnd, FormRect)
                Call GetWindowRect(Screen.ActiveForm.hwnd, ActiveFormRect)
                If FormRect.Right - 58 < ActiveFormRect.Left Or FormRect.Right - 55 > ActiveFormRect.Right Or FormRect.Top + 20 < ActiveFormRect.Top Or FormRect.Top + 11 > ActiveFormRect.Bottom Then
                    Call GetWindowRect(frmMain.hwnd, FormRect)
                    Call SetWindowPos(cmdButtonHwnd, HWND_TOP, FormRect.Right - 55, FormRect.Top + 11, 17, 12, SWP_FRAMECHANGED)
                End If
            End If
    End Select
End Function

